/*
 * File:	clipdef2.cc
 * Purpose:	Function definitions
 * Author:	Julian Smart
 * Created:	1993
 * Updated:	
 * Copyright:	(c) 1993, AIAI, University of Edinburgh
 */

static const char sccsid[] = "%W% %G%";

#include "wx_hash.h"
#include "clips2c.h"

void InitializeHardy(void)
{
  AddClipsFunction(cInteger, "quit", "HardyQuit", cInteger);
  AddClipsFunction(cInteger, "hardy-load-index", "HardyLoadIndex", cString);
  AddClipsFunction(cInteger, "hardy-save-index", "HardySaveIndex", cString);
  AddClipsFunction(cInteger, "help-load-file", "HardyHelpLoadFile", cString);
  AddClipsFunction(cInteger, "help-display-contents", "HardyHelpDisplayContents", cString);
  AddClipsFunction(cInteger, "help-display-section", "HardyHelpDisplaySection", cInteger);
  AddClipsFunction(cInteger, "help-display-block", "HardyHelpDisplayBlock", cInteger);
  AddClipsFunction(cInteger, "help-keyword-search", "HardyHelpKeywordSearch", cString);
  AddClipsFunction(cInteger, "dde-advice-global", "HardyDdeAdviseGlobal", cString, cString);
  AddClipsFunction(cInteger, "card-create", "HardyCardCreate", cInteger, cString, cInteger);
  AddClipsFunction(cInteger, "card-delete", "HardyCardDelete", cInteger, cIntegerOpt);
  AddClipsFunction(cInteger, "card-move", "HardyCardMove", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "card-is-shown", "HardyCardIsShown", cInteger);
  AddClipsFunction(cInteger, "card-is-modified", "HardyCardIsModified", cInteger);
  AddClipsFunction(cInteger, "card-get-x", "HardyCardGetX", cInteger);
  AddClipsFunction(cInteger, "card-get-y", "HardyCardGetY", cInteger);
  AddClipsFunction(cInteger, "card-get-width", "HardyCardGetWidth", cInteger);
  AddClipsFunction(cInteger, "card-get-height", "HardyCardGetHeight", cInteger);
  AddClipsFunction(cInteger, "card-get-frame", "HardyCardGetFrame", cInteger);
  AddClipsFunction(cInteger, "text-card-load-file", "HardyTextCardLoadFile", cInteger, cString);
  AddClipsFunction(cString,  "card-get-string-attribute", "HardyCardGetStringAttribute",
   cInteger, cString);
  AddClipsFunction(cInteger, "card-set-string-attribute", "HardyCardSetStringAttribute",
   cInteger, cString, cString);
  AddClipsFunction(cInteger, "card-set-status-text", "HardyCardSetStatusText", cInteger, cString);
  AddClipsFunction(cInteger, "card-find-by-title", "HardyCardFindByTitle", cString);
  AddClipsFunction(cInteger, "hardy-get-top-card", "HardyGetTopCard", cInteger);
  AddClipsFunction(cInteger, "card-show", "HardyCardShow", cInteger, cInteger);
  AddClipsFunction(cInteger, "card-iconize", "HardyCardIconize", cInteger, cIntegerOpt);
  AddClipsFunction(cInteger, "card-set-icon", "HardyCardSetIcon", cInteger, cInteger);
  AddClipsFunction(cInteger, "card-quit", "HardyCardQuit", cInteger);
  AddClipsFunction(cInteger, "item-goto", "HardyItemGoto", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "link-cards", "HardyLinkCards", cInteger, cInteger);
  AddClipsFunction(cInteger, "link-items", "HardyLinkItems", cInteger, cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "card-get-special-item", "HardyCardGetSpecialItem", cInteger);
  AddClipsFunction(cInteger, "link-get-to", "HardyLinkGetTo", cInteger);
  AddClipsFunction(cInteger, "link-get-from", "HardyLinkGetFrom", cInteger);
  AddClipsFunction(cInteger, "link-get-card-to", "HardyLinkGetCardTo", cInteger);
  AddClipsFunction(cInteger, "link-get-card-from", "HardyLinkGetCardFrom", cInteger);
  AddClipsFunction(cString,  "link-get-type", "HardyLinkGetType", cInteger);
  AddClipsFunction(cString,  "link-get-kind", "HardyLinkGetKind", cInteger);
  AddClipsFunction(cString,  "item-get-type", "HardyItemGetType", cInteger, cInteger);
  AddClipsFunction(cString,  "item-get-kind", "HardyItemGetKind", cInteger, cInteger);
  AddClipsFunction(cInteger, "card-get-first-item", "HardyCardGetFirstItem", cInteger);
  AddClipsFunction(cInteger, "card-get-next-item", "HardyCardGetNextItem");
  AddClipsFunction(cInteger, "item-get-first-link", "HardyItemGetFirstLink", cInteger, cInteger);
  AddClipsFunction(cInteger, "item-get-next-link", "HardyItemGetNextLink");
  AddClipsFunction(cInteger, "register-event-handler", "HardyRegisterEventHandler",
    cString, cString, cFunction);
  AddClipsFunction(cInteger, "object-is-valid", "HardyObjectIsValid", cInteger, cInteger);

/************************************************************************
 * CUSTOMISATION FUNCTIONS
 *
 ************************************************************************/

  AddClipsFunction(cInteger, "hardy-set-name", "HardySetName", cString);
  AddClipsFunction(cInteger, "hardy-set-title", "HardySetTitle", cString);
  AddClipsFunction(cInteger, "hardy-set-help-file", "HardySetHelpFile", cString);
  AddClipsFunction(cInteger, "hardy-set-custom-help-file", "HardySetCustomHelpFile", cString);
  AddClipsFunction(cInteger, "hardy-set-author", "HardySetAuthor", cString);
  AddClipsFunction(cInteger, "hardy-set-about-string", "HardySetAboutString", cString);

/************************************************************************
 * DIAGRAM CARD FUNCTIONS
 *
 ************************************************************************/

  // Cut, copy and paste
  AddClipsFunction(cInteger, "diagram-card-copy", "HardyDiagramCardCopy", cInteger);
  AddClipsFunction(cInteger, "diagram-card-cut", "HardyDiagramCardCut", cInteger);
  AddClipsFunction(cInteger, "diagram-card-paste", "HardyDiagramCardPaste", cInteger);

  AddClipsFunction(cInteger, "card-get-print-width", "HardyCardGetPrintWidth", cInteger);
  AddClipsFunction(cInteger, "card-get-print-height", "HardyCardGetPrintHeight", cInteger);
  AddClipsFunction(cInteger, "diagram-card-create", "HardyDiagramCardCreat", cInteger, cString, cInteger);
  AddClipsFunction(cInteger, "diagram-card-create-expansion", "HardyDiagramCardCreateExpansion", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-card-find-root", "HardyDiagramCardFindRoot", cInteger);
  AddClipsFunction(cInteger, "diagram-card-load-file", "HardyDiagramCardLoadFile", cInteger, cString);
  AddClipsFunction(cInteger, "diagram-card-save-file", "HardyDiagramCardSaveFile", cInteger, cString);
  AddClipsFunction(cInteger, "diagram-card-clear-canvas", "HardyDiagramCardClearCanvas", cInteger);
  AddClipsFunction(cInteger, "diagram-card-print-hierarchy", "HardyDiagramCardPrintHierarchy", cInteger);
  AddClipsFunction(cInteger, "diagram-card-save-bitmap", "HardyDiagramCardSaveBitmap", cInteger, cString);
  AddClipsFunction(cInteger, "diagram-card-save-metafile", "HardyDiagramCardSaveMetafile", cInteger, cString);
  AddClipsFunction(cInteger, "convert-bitmap-to-rtf", "HardyConvertBitmapToRTF", cString, cString);
  AddClipsFunction(cInteger, "convert-metafile-to-rtf", "HardyConvertMetafileToRTF", cString, cString);
//  AddClipsFunction(cInteger, "copy-diagram", "HardyCopyDiagram", cInteger, cInteger);
  AddClipsFunction(cInteger, "card-deselect-all", "HardyCardDeselectAll", cInteger);
  AddClipsFunction(cInteger, "card-select-all", "HardyCardSelectAll", cInteger);
  AddClipsFunction(cInteger, "diagram-image-set-pen-colour", "HardyDiagramImageSetPenColour", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "diagram-image-set-brush-colour", "HardyDiagramImageSetBrushColour", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "diagram-image-set-text-colour", "HardyDiagramImageSetTextColour", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "diagram-card-delete-all-images", "HardyDiagramCardDeleteAllImages", cInteger);
  AddClipsFunction(cInteger, "diagram-card-get-first-node-image", "HardyDiagramCardGetFirstNodeImage", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-card-get-next-node-image", "HardyDiagramCardGetNextNodeImage");
  AddClipsFunction(cInteger, "diagram-card-get-first-arc-image", "HardyDiagramCardGetFirstArcImage", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-card-get-next-arc-image", "HardyDiagramCardGetNextArcImage");
  AddClipsFunction(cInteger, "diagram-card-get-first-node", "HardyDiagramCardGetFirstNode", cInteger);
  AddClipsFunction(cInteger, "diagram-card-get-next-node", "HardyDiagramCardGetNextNode");
  AddClipsFunction(cInteger, "diagram-card-get-first-arc", "HardyDiagramCardGetFirstArc", cInteger);
  AddClipsFunction(cInteger, "diagram-card-get-next-arc", "HardyDiagramCardGetNextArc");
  AddClipsFunction(cInteger, "diagram-card-get-first-descendant", "HardyDiagramCardGetFirstDescendant", cInteger);
  AddClipsFunction(cInteger, "diagram-card-get-next-descendant", "HardyDiagramCardGetNextDescendant");
  AddClipsFunction(cInteger, "diagram-image-get-first-descendant", "HardyDiagramImageGetFirstExpansion", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-image-get-next-expansion", "HardyDiagramImageGetNextExpansion");
  AddClipsFunction(cInteger, "diagram-image-selected", "HardyDiagramImageSelected", cInteger, cInteger);

/************************************************************************
 * IMAGE/OBJECT CREATION & MANIPULATION
 *
 ************************************************************************/

  AddClipsFunction(cInteger, "node-image-create", "HardyNodeImageCreate", cInteger, cString);
  AddClipsFunction(cInteger, "node-image-duplicate", "HardyNodeImageDuplicate", cInteger, cInteger);
  AddClipsFunction(cInteger, "arc-image-create", "HardyArcImageCreate", cInteger, cString,
                         cInteger, cInteger, cInteger, cInteger, cStringOpt);
  AddClipsFunction(cInteger, "arc-image-is-spline", "HardyArcImageIsSpline", cInteger, cInteger);
  AddClipsFunction(cInteger, "arc-image-set-spline", "HardyArcImageSetSpline", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-image-delete", "HardyDiagramImageDelete", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-image-move", "HardyDiagramImageMove", cInteger, cInteger, cReal, cReal);
  AddClipsFunction(cInteger, "diagram-image-resize", "HardyDiagramImageResize", cInteger, cInteger, cReal, cReal);
  AddClipsFunction(cInteger, "diagram-image-draw", "HardyDiagramImageDraw", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-image-erase", "HardyDiagramImageErase", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-image-select", "HardyDiagramImageSelect", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-object-set-format-string", "HardyDiagramObjectSetFormatString", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "diagram-object-format-text", "HardyDiagramObjectFormatText", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-image-draw-text", "HardyDiagramImageDrawText", cInteger, cInteger, cString, cStringOpt);
  AddClipsFunction(cInteger, "diagram-card-redraw", "HardyDiagramCardRedraw", cInteger);
  AddClipsFunction(cInteger, "diagram-card-layout-tree", "HardyDiagramCardLayoutTree", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-card-layout-graph", "HardyDiagramCardLayoutGraph", cInteger);
  AddClipsFunction(cInteger, "diagram-card-set-layout-parameters", "HardyDiagramCardSetLayoutParameters", cInteger,
    cReal, cReal, cReal, cReal, cReal, cReal);
  AddClipsFunction(cInteger, "diagram-object-get-first-image", "HardyDiagramObjectGetFirstImage", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-object-get-next-image", "HardyDiagramObjectGetNextImage");
  AddClipsFunction(cInteger, "node-image-get-first-arc-image", "HardyNodeImageGetFirstArcImage", cInteger, cInteger);
  AddClipsFunction(cInteger, "node-image-get-next-arc-image", "HardyNodeImageGetNextArcImage");
  AddClipsFunction(cInteger, "arc-image-get-image-to", "HardyArcImageGetImageTo", cInteger, cInteger);
  AddClipsFunction(cInteger, "arc-image-get-image-from", "HardyArcImageGetImageFrom", cInteger, cInteger);
  AddClipsFunction(cInteger, "arc-image-get-attachment-to", "HardyArcImageGetAttachmentTo", cInteger, cInteger);
  AddClipsFunction(cInteger, "arc-image-get-attachment-from", "HardyArcImageGetAttachmentFrom", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-image-get-object", "HardyDiagramImageGetObject", cInteger, cInteger);
  AddClipsFunction(cInteger, "node-object-get-first-arc-object", "HardyNodeObjectGetFirstArcObject", cInteger, cInteger);
  AddClipsFunction(cInteger, "node-object-get-next-arc-object", "HardyNodeObjectGetNextArcObject");
  AddClipsFunction(cInteger, "diagram-image-get-item", "HardyDiagramImageGetItem", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-item-get-image", "HardyDiagramItemGetImage", cInteger, cInteger);

/************************************************************************
 * OBJECT/IMAGE ATTRIBUTE ACCESSORS
 *
 ************************************************************************/

  AddClipsFunction(cString, "diagram-object-get-string-attribute", "HardyDiagramObjectGetStringAttribute", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "diagram-object-set-string-attribute", "HardyDiagramObjectSetStringAttribute", cInteger, cInteger,
                                    cString, cString);
  AddClipsFunction(cString, "diagram-object-get-first-attribute", "HardyDiagramObjectGetFirstAttribute", cInteger, cInteger);
  AddClipsFunction(cString, "diagram-get-next-attribute", "HardyDiagramObjectGetNextAttribute");
  AddClipsFunction(cInteger, "diagram-object-add-attribute", "HardyDiagramObjectAddAttribute", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "diagram-object-delete-attribute", "HardyDiagramObjectDeleteAttribute", cInteger, cInteger, cString);
  AddClipsFunction(cReal, "diagram-image-get-x", "HardyDiagramImageGetX", cInteger, cInteger);
  AddClipsFunction(cReal, "diagram-image-get-y", "HardyDiagramImageGetY", cInteger, cInteger);
  AddClipsFunction(cReal, "diagram-image-get-width", "HardyDiagramImageGetWidth", cInteger, cInteger);
  AddClipsFunction(cReal, "diagram-image-get-height", "HardyDiagramImageGetHeight", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-image-get-card", "HardyDiagramImageGetCard");

/************************************************************************
 * COMPOSITE/ANNOTATION/CONTAINER FUNCTIONS
 *
 ************************************************************************/

  AddClipsFunction(cInteger, "node-image-is-composite", "HardyNodeImageIsComposite", cInteger, cInteger);
  AddClipsFunction(cInteger, "node-image-get-first-child", "HardyNodeImageGetFirstChild", cInteger, cInteger);
  AddClipsFunction(cInteger, "node-image-get-next-child", "HardyNodeImageGetNextChild");
  AddClipsFunction(cInteger, "diagram-image-add-annotation", "HardyDiagramImageAddAnnotation", cInteger, cInteger,
   cString, cString);
  AddClipsFunction(cInteger, "diagram-image-delete-annotation", "HardyDiagramImageDeleteAnnotation", cInteger, cInteger,
   cInteger);
  AddClipsFunction(cInteger, "diagram-image-get-first-annotation", "HardyDiagramImageGetFirstAnnotation", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-image-get-next-annotation", "HardyDiagramImageGetNextAnnotation");
  AddClipsFunction(cString, "diagram-image-annotaton-get-name", "HardyDiagramImageAnnotationGetName", cInteger, cInteger,
    cInteger);
  AddClipsFunction(cString, "diagram-image-annotaton-get-logical-name", "HardyDiagramImageAnnotationGetName", cInteger, cInteger,
    cInteger);
  AddClipsFunction(cString, "diagram-image-annotaton-get-drop-site", "HardyDiagramImageAnnotationGetDropSite", cInteger, cInteger,
    cInteger);
  AddClipsFunction(cInteger, "node-image-is-container", "HardyNodeImageIsContainer", cInteger, cInteger);
  AddClipsFunction(cInteger, "node-image-get-first-container-region", "HardyNodeImageGetFirstContainerRegion",
   cInteger, cInteger);
  AddClipsFunction(cInteger, "node-image-get-next-container-region", "HardyNodeImageGetNextContainerRegion");
  AddClipsFunction(cInteger, "container-region-add-node-image", "HardyContainerRegionAddNodeImage",
   cInteger, cInteger, cInteger, cReal, cReal);
  AddClipsFunction(cInteger, "container-region-remove-node-image", "HardyContainerRegionRemoveNodeImage",
   cInteger, cInteger, cInteger, cReal, cReal);

/************************************************************************
 * JUNCTION NODE FUNCTIONS
 *
 ************************************************************************/

  AddClipsFunction(cInteger, "arc-image-is-stem", "HardyArcImageIsStem", cInteger, cInteger);
  AddClipsFunction(cInteger, "arc-image-is-leg", "HardyArcImageIsLeg", cInteger, cInteger);
  AddClipsFunction(cInteger, "node-image-is-junction", "HardyJunctionImageIsJunction", cInteger, cInteger);

/************************************************************************
 * PALETTE FUNCTIONS
 *
 ************************************************************************/

  AddClipsFunction(cString, "diagram-palette-get-node-selection", "HardyDiagramPaletteGetNodeSelection", cInteger);
  AddClipsFunction(cString, "diagram-palette-get-arc-selection", "HardyDiagramPaletteGetArcSelection", cInteger);
  AddClipsFunction(cString, "diagram-palette-get-arc-selection-image", "HardyDiagramPaletteGetArcSelectionImage", cInteger);
  AddClipsFunction(cString, "diagram-palette-get-first-annotation-selection", "HardyDiagramPaletteGetFirstAnnotationSelection", cInteger,
              cString);
  AddClipsFunction(cString, "diagram-palette-get-next-annotation-selection", "HardyDiagramPaletteGetNextAnnotationSelection");
  AddClipsFunction(cInteger, "diagram-palette-set-node-selection", "HardyDiagramPaletteSetNodeSelection", cInteger,
              cString, cInteger);
  AddClipsFunction(cInteger, "diagram-palette-set-arc-selection", "HardyDiagramPaletteSetArcSelection", cInteger,
              cString, cInteger);
  AddClipsFunction(cInteger, "diagram-palette-set-annotation-selection", "HardyDiagramPaletteSetAnnotationSelection", cInteger,
              cString, cInteger);

/************************************************************************
 * HYPERTEXT CARD FUNCTIONS
 *
 ************************************************************************/

  AddClipsFunction(cInteger, "hypertext-card-create", "HardyHypertextCardCreate", cInteger, cString, cInteger);
  AddClipsFunction(cInteger, "hypertext-block-selected", "HardyHypertextBlockSelected", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-block-add", "HardyHypertextBlockAdd", cInteger, cInteger, cInteger, cInteger, cInteger,
    cInteger);
  AddClipsFunction(cInteger, "hypertext-card-insert-text", "HardyHypertextCardInsertText", cInteger, cInteger, cInteger,  cString);
  AddClipsFunction(cString, "hypertext-block-get-text", "HardyHypertextBlockGetText", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-card-string-search", "HardyHypertextCardStringSearch", cInteger, cString,
    cInteger, cInteger);
  AddClipsFunction(cString, "hypertext-card-get-span-text", "HardyHypertextCardGetSpanText", cInteger, cInteger, cInteger,
    cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-card-get-current-line", "HardyHypertextCardGetCurrentLine", cInteger);
  AddClipsFunction(cInteger, "hypertext-card-get-current-char", "HardyHypertextCardGetCurrentChar", cInteger);

  AddClipsFunction(cInteger, "hypertext-card-get-no-lines", "HardyHypertextCardGetNoLines", cInteger);

  AddClipsFunction(cInteger, "hypertext-card-get-line-length", "HardyHypertextCardGetLineLength", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-card-get-offset-position", "HardyHypertextCardGetOffsetPosition", cInteger, cInteger, cInteger, cInteger);

  AddClipsFunction(cInteger, "hypertext-block-get-type", "HardyHypertextBlockGetType", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-block-set-type", "HardyHypertextBlockSetType", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-block-clear", "HardyHypertextBlockClear", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-block-get-item", "HardyHypertextBlockGetItem", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-item-get-block", "HardyHypertextItemGetBlock", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-card-get-first-selection", "HardyHypertextCardGetFirstSelection", cInteger);
  AddClipsFunction(cInteger, "hypertext-card-get-next-selection", "HardyHypertextCardGetNextSelection");
  AddClipsFunction(cInteger, "hypertext-card-save-file", "HardyHypertextCardSaveFile", cInteger, cString);
  AddClipsFunction(cInteger, "hypertext-card-load-file", "HardyHypertextCardLoadFile", cInteger, cString);
}
