/*
 * File:	clipdef3.cc
 * Purpose:	Function definitions: HARDY compatibility (old) functions
 * Author:	Julian Smart
 * Created:	1994
 * Updated:	
 * Copyright:	(c) 1993, AIAI, University of Edinburgh
 */

static const char sccsid[] = "%W% %G%";

#include "wx_hash.h"
#include "clips2c.h"

void InitializeHardyCompatibility(void)
{
  AddClipsFunction(cInteger, "quit", "HardyQuit", cInteger);
  AddClipsFunction(cInteger, "load-index", "HardyLoadIndex", cString);
  AddClipsFunction(cInteger, "save-index", "HardySaveIndex", cString);
  AddClipsFunction(cInteger, "help-load-file", "HardyHelpLoadFile", cString);
  AddClipsFunction(cInteger, "help-display-contents", "HardyHelpDisplayContents", cString);
  AddClipsFunction(cInteger, "help-display-section", "HardyHelpDisplaySection", cInteger);
  AddClipsFunction(cInteger, "help-display-block", "HardyHelpDisplayBlock", cInteger);
  AddClipsFunction(cInteger, "help-keyword-search", "HardyHelpKeywordSearch", cString);
  AddClipsFunction(cInteger, "dde-advice-global", "HardyDdeAdviseGlobal", cString, cString);
  AddClipsFunction(cInteger, "create-card", "HardyCardCreate", cInteger, cString, cInteger);
  AddClipsFunction(cInteger, "delete-card", "HardyCardDelete", cInteger, cIntegerOpt);
  AddClipsFunction(cInteger, "move-card", "HardyCardMove", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "is-card-shown", "HardyCardIsShown", cInteger);
  AddClipsFunction(cInteger, "is-card-modified", "HardyCardIsModified", cInteger);
  AddClipsFunction(cInteger, "get-card-x", "HardyCardGetX", cInteger);
  AddClipsFunction(cInteger, "get-card-y", "HardyCardGetY", cInteger);
  AddClipsFunction(cInteger, "get-card-width", "HardyCardGetWidth", cInteger);
  AddClipsFunction(cInteger, "get-card-height", "HardyCardGetHeight", cInteger);
  AddClipsFunction(cInteger, "load-text-file", "HardyTextCardLoadFile", cInteger, cString);
  AddClipsFunction(cString,  "get-card-string-attribute", "HardyCardGetStringAttribute",
   cInteger, cString);
  AddClipsFunction(cInteger, "set-card-string-attribute", "HardyCardSetStringAttribute",
   cInteger, cString, cString);
  AddClipsFunction(cInteger, "set-card-status-text", "HardyCardSetStatusText", cInteger, cString);
  AddClipsFunction(cInteger, "find-card-by-title", "HardyCardFindByTitle", cString);
  AddClipsFunction(cInteger, "get-top-card", "HardyGetTopCard", cInteger);
  AddClipsFunction(cInteger, "show-card", "HardyCardShow", cInteger, cInteger);
  AddClipsFunction(cInteger, "iconize-card", "HardyCardIconize", cInteger, cIntegerOpt);
  AddClipsFunction(cInteger, "card-set-icon", "HardyCardSetIcon", cInteger, cInteger);
  AddClipsFunction(cInteger, "quit-card", "HardyCardQuit", cInteger);
  AddClipsFunction(cInteger, "goto-item", "HardyItemGoto", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "link-cards", "HardyLinkCards", cInteger, cInteger);
  AddClipsFunction(cInteger, "link-items", "HardyLinkItems", cInteger, cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "get-card-special-item", "HardyCardGetSpecialItem", cInteger);
  AddClipsFunction(cInteger, "get-link-to", "HardyLinkGetTo", cInteger);
  AddClipsFunction(cInteger, "get-link-from", "HardyLinkGetFrom", cInteger);
  AddClipsFunction(cInteger, "get-link-card-to", "HardyLinkGetCardTo", cInteger);
  AddClipsFunction(cInteger, "get-link-card-from", "HardyLinkGetCardFrom", cInteger);
  AddClipsFunction(cString,  "get-link-type", "HardyLinkGetType", cInteger);
  AddClipsFunction(cString,  "get-link-kind", "HardyLinkGetKind", cInteger);
  AddClipsFunction(cString,  "get-item-type", "HardyItemGetType", cInteger, cInteger);
  AddClipsFunction(cString,  "get-item-kind", "HardyItemGetKind", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-first-card-item", "HardyCardGetFirstItem", cInteger);
  AddClipsFunction(cInteger, "get-next-card-item", "HardyCardGetNextItem");
  AddClipsFunction(cInteger, "get-first-item-link", "HardyItemGetFirstLink", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-next-item-link", "HardyItemGetNextLink");
  AddClipsFunction(cInteger, "register-event-handler", "HardyRegisterEventHandler",
    cString, cString, cFunction);
  AddClipsFunction(cInteger, "is-object", "HardyObjectIsValid", cInteger, cInteger);

/************************************************************************
 * DIAGRAM CARD FUNCTIONS
 *
 ************************************************************************/

  AddClipsFunction(cInteger, "get-card-print-width", "HardyCardGetPrintWidth", cInteger);
  AddClipsFunction(cInteger, "get-card-print-height", "HardyCardGetPrintHeight", cInteger);
  AddClipsFunction(cInteger, "create-diagram-card", "HardyDiagramCardCreat", cInteger, cString, cInteger);
  AddClipsFunction(cInteger, "create-expansion-card", "HardyDiagramCardCreateExpansion", cInteger, cInteger);
  AddClipsFunction(cInteger, "find-diagram-root", "HardyDiagramCardFindRoot", cInteger);
  AddClipsFunction(cInteger, "load-diagram", "HardyDiagramCardLoadFile", cInteger, cString);
  AddClipsFunction(cInteger, "save-diagram", "HardyDiagramCardSaveFile", cInteger, cString);
  AddClipsFunction(cInteger, "clear-card-canvas", "HardyDiagramCardClearCanvas", cInteger);
  AddClipsFunction(cInteger, "print-hierarchy-to-files", "HardyDiagramCardPrintHierarchy", cInteger);
  AddClipsFunction(cInteger, "diagram-save-bitmap", "HardyDiagramCardSaveBitmap", cInteger, cString);
  AddClipsFunction(cInteger, "diagram-save-metafile", "HardyDiagramCardSaveMetafile", cInteger, cString);
  AddClipsFunction(cInteger, "convert-bitmap-to-rtf", "HardyConvertBitmapToRTF", cString, cString);
  AddClipsFunction(cInteger, "convert-metafile-to-rtf", "HardyConvertMetafileToRTF", cString, cString);
//  AddClipsFunction(cInteger, "copy-diagram", "HardyCopyDiagram", cInteger, cInteger);
  AddClipsFunction(cInteger, "deselect-all", "HardyCardDeselectAll", cInteger);
  AddClipsFunction(cInteger, "set-image-pen-colour", "HardyDiagramImageSetPenColour", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "set-image-brush-colour", "HardyDiagramImageSetBrushColour", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "set-image-text-colour", "HardyDiagramImageSetTextColour", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "delete-all-images", "HardyDiagramCardDeleteAllImages", cInteger);
  AddClipsFunction(cInteger, "get-first-card-node-image", "HardyDiagramCardGetFirstNodeImage", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-next-card-node-image", "HardyDiagramCardGetNextNodeImage");
  AddClipsFunction(cInteger, "get-first-card-arc-image", "HardyDiagramCardGetFirstArcImage", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-next-card-arc-image", "HardyDiagramCardGetNextArcImage");
  AddClipsFunction(cInteger, "get-first-card-node", "HardyDiagramCardGetFirstNode", cInteger);
  AddClipsFunction(cInteger, "get-next-card-node", "HardyDiagramCardGetNextNode");
  AddClipsFunction(cInteger, "get-first-card-arc", "HardyDiagramCardGetFirstArc", cInteger);
  AddClipsFunction(cInteger, "get-next-card-arc", "HardyDiagramCardGetNextArc");
  AddClipsFunction(cInteger, "get-first-expansion-descendant", "HardyDiagramCardGetFirstDescendant", cInteger);
  AddClipsFunction(cInteger, "get-next-expansion-descendant", "HardyDiagramCardGetNextDescendant");
  AddClipsFunction(cInteger, "get-first-image-descendant", "HardyDiagramImageGetFirstExpansion", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-next-image-expansion", "HardyDiagramImageGetNextExpansion");
  AddClipsFunction(cInteger, "image-selected", "HardyDiagramImageSelected", cInteger, cInteger);

/************************************************************************
 * IMAGE/OBJECT CREATION & MANIPULATION
 *
 ************************************************************************/

  AddClipsFunction(cInteger, "create-node-image", "HardyNodeImageCreate", cInteger, cString);
  AddClipsFunction(cInteger, "duplicate-node-image", "HardyNodeImageDuplicate", cInteger, cInteger);
  AddClipsFunction(cInteger, "create-arc-image", "HardyArcImageCreate", cInteger, cString,
                         cInteger, cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "delete-image", "HardyDiagramImageDelete", cInteger, cInteger);
  AddClipsFunction(cInteger, "move-image", "HardyDiagramImageMove", cInteger, cInteger, cReal, cReal);
  AddClipsFunction(cInteger, "resize-image", "HardyDiagramImageResize", cInteger, cInteger, cReal, cReal);
  AddClipsFunction(cInteger, "draw-image", "HardyDiagramImageDraw", cInteger, cInteger);
  AddClipsFunction(cInteger, "erase-image", "HardyDiagramImageErase", cInteger, cInteger);
  AddClipsFunction(cInteger, "select-image", "HardyDiagramImageSelect", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "set-object-format-string", "HardyDiagramObjectSetFormatString", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "format-object-text", "HardyDiagramObjectFormatText", cInteger, cInteger);
  AddClipsFunction(cInteger, "draw-image-text", "HardyDiagramImageDrawText", cInteger, cInteger, cString, cStringOpt);
  AddClipsFunction(cInteger, "redraw-diagram", "HardyDiagramCardRedraw", cInteger);
  AddClipsFunction(cInteger, "diagram-layout-tree", "HardyDiagramCardLayoutTree", cInteger, cInteger);
  AddClipsFunction(cInteger, "diagram-layout-graph", "HardyDiagramCardLayoutGraph", cInteger);
  AddClipsFunction(cInteger, "diagram-set-layout-parameters", "HardyDiagramCardSetLayoutParameters", cInteger,
    cReal, cReal, cReal, cReal, cReal, cReal);
  AddClipsFunction(cInteger, "get-first-object-image", "HardyDiagramObjectGetFirstImage", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-next-object-image", "HardyDiagramObjectGetNextImage");
  AddClipsFunction(cInteger, "get-first-node-image-arc", "HardyNodeImageGetFirstArcImage", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-next-node-image-arc", "HardyNodeImageGetNextArcImage");
  AddClipsFunction(cInteger, "get-arc-image-to", "HardyArcImageGetImageTo", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-arc-image-from", "HardyArcImageGetImageFrom", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-arc-image-to-attachment", "HardyArcImageGetAttachmentTo", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-arc-image-from-attachment", "HardyArcImageGetAttachmentFrom", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-object-from-image", "HardyDiagramImageGetObject", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-first-node-object-arc", "HardyNodeObjectGetFirstArcObject", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-next-node-object-arc", "HardyNodeObjectGetNextArcObject");
  AddClipsFunction(cInteger, "get-image-item", "HardyDiagramImageGetItem", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-item-image", "HardyDiagramItemGetImage", cInteger, cInteger);

/************************************************************************
 * OBJECT/IMAGE ATTRIBUTE ACCESSORS
 *
 ************************************************************************/

  AddClipsFunction(cString, "get-object-string-attribute", "HardyDiagramObjectGetStringAttribute", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "set-object-string-attribute", "HardyDiagramObjectSetStringAttribute", cInteger, cInteger,
                                    cString, cString);
  AddClipsFunction(cString, "get-first-object-attribute", "HardyDiagramObjectGetFirstAttribute", cInteger, cInteger);
  AddClipsFunction(cString, "get-next-object-attribute", "HardyDiagramObjectGetNextAttribute");
  AddClipsFunction(cInteger, "add-object-attribute", "HardyDiagramObjectAddAttribute", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "delete-object-attribute", "HardyDiagramObjectDeleteAttribute", cInteger, cInteger, cString);
  AddClipsFunction(cReal, "get-image-x", "HardyDiagramImageGetX", cInteger, cInteger);
  AddClipsFunction(cReal, "get-image-y", "HardyDiagramImageGetY", cInteger, cInteger);
  AddClipsFunction(cReal, "get-image-width", "HardyDiagramImageGetWidth", cInteger, cInteger);
  AddClipsFunction(cReal, "get-image-height", "HardyDiagramImageGetHeight", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-card-for-image", "HardyDiagramImageGetCard");

/************************************************************************
 * HYPERTEXT CARD FUNCTIONS
 *
 ************************************************************************/

  AddClipsFunction(cInteger, "create-hypertext-card", "HardyHypertextCardCreate", cInteger, cString, cInteger);
  AddClipsFunction(cInteger, "hypertext-block-selected", "HardyHypertextBlockSelected", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-add-block", "HardyHypertextBlockAdd", cInteger, cInteger, cInteger, cInteger, cInteger,
    cInteger);
  AddClipsFunction(cInteger, "hypertext-insert-text", "HardyHypertextCardInsertText", cInteger, cInteger, cInteger,  cString);
  AddClipsFunction(cString, "get-block-text", "HardyHypertextBlockGetText", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-string-search", "HardyHypertextCardStringSearch", cInteger, cString,
    cInteger, cInteger);
  AddClipsFunction(cString, "hypertext-get-span-text", "HardyHypertextCardGetSpanText", cInteger, cInteger, cInteger,
    cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-get-current-line", "HardyHypertextCardGetCurrentLine", cInteger);
  AddClipsFunction(cInteger, "hypertext-get-current-char", "HardyHypertextCardGetCurrentChar", cInteger);

  AddClipsFunction(cInteger, "hypertext-get-no-lines", "HardyHypertextCardGetNoLines", cInteger);

  AddClipsFunction(cInteger, "hypertext-get-line-length", "HardyHypertextCardGetLineLength", cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-get-offset-position", "HardyHypertextCardGetOffsetPosition", cInteger, cInteger, cInteger, cInteger);

  AddClipsFunction(cInteger, "get-block-type", "HardyHypertextBlockGetType", cInteger, cInteger);
  AddClipsFunction(cInteger, "set-block-type", "HardyHypertextBlockSetType", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "hypertext-clear-block", "HardyHypertextBlockClear", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-block-item", "HardyHypertextBlockGetItem", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-item-block", "HardyHypertextItemGetBlock", cInteger, cInteger);
  AddClipsFunction(cInteger, "get-first-block-selection", "HardyHypertextCardGetFirstSelection", cInteger);
  AddClipsFunction(cInteger, "get-next-block-selection", "HardyHypertextCardGetNextSelection");
  AddClipsFunction(cInteger, "save-hypertext", "HardyHypertextCardSaveFile", cInteger, cString);
  AddClipsFunction(cInteger, "load-hypertext", "HardyHypertextCardLoadFile", cInteger, cString);
}
