/*
 * File:	clipdef4.cc
 * Purpose:     wxCLIPS function definitions
 * Author:	Julian Smart
 * Created:	1993
 * Updated:	
 * Copyright:	(c) 1993, AIAI, University of Edinburgh
 */

static const char sccsid[] = "%W% %G%";

#include "wx_hash.h"
#include "clips2c.h"

void InitializeWXClips(void)
{
  /*
   * wxCLIPS functions
   *
   */
   
  AddClipsFunction(cString, "my-function", "MyFunction", cString, cString);
  AddClipsFunction(cString, "get-platform", "wxcGetPlatform");
  AddClipsFunction(cVoid,   "clean-windows", "wxcCleanWindows");
  AddClipsFunction(cInteger, "window-delete", "wxcWindowDelete", cInteger);
  AddClipsFunction(cInteger, "window-show", "wxcWindowShow", cInteger, cIntegerOpt);
  AddClipsFunction(cInteger, "window-show", "wxcWindowGetParent", cInteger);
  AddClipsFunction(cInteger, "window-add-callback", "wxcWindowAddCallback", cInteger, cString, cFunction);
  AddClipsFunction(cInteger, "window-get-width", "wxcWindowGetWidth", cInteger);
  AddClipsFunction(cInteger, "window-get-height", "wxcWindowGetHeight", cInteger);
  AddClipsFunction(cInteger, "window-get-client-width", "wxcWindowGetClientWidth", cInteger);
  AddClipsFunction(cInteger, "window-get-client-height", "wxcWindowGetClientHeight", cInteger);
  AddClipsFunction(cInteger, "window-get-x", "wxcWindowGetX", cInteger);
  AddClipsFunction(cInteger, "window-get-y", "wxcWindowGetY", cInteger);
  AddClipsFunction(cInteger, "window-get-parent", "wxcWindowGetParent", cInteger);
  AddClipsFunction(cInteger, "window-set-size", "wxcWindowSetSize", cInteger, cInteger, cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "window-set-client-size", "wxcWindowSetClientSize", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "window-set-focus", "wxcWindowSetFocus", cInteger);
  AddClipsFunction(cInteger, "window-fit", "wxcWindowFit", cInteger);
  AddClipsFunction(cInteger, "window-centre", "wxcWindowCentre", cInteger, cStringOpt);
  AddClipsFunction(cInteger, "window-make-modal", "wxcWindowMakeModal", cInteger, cInteger);
  AddClipsFunction(cInteger, "panel-set-default", "wxcPanelItemSetDefault", cInteger);
  AddClipsFunction(cInteger, "panel-item-set-label", "wxcPanelItemSetLabel", cInteger, cString);
  AddClipsFunction(cString,  "panel-item-get-label", "wxcPanelItemGetLabel", cInteger);
  AddClipsFunction(cInteger, "dialog-box-create", "wxcDialogBoxCreate", cInteger, cString, cInteger,
    cIntegerOpt, cIntegerOpt, cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "panel-create", "wxcPanelCreate", cInteger,
    cIntegerOpt, cIntegerOpt, cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "panel-set-label-position", "wxcPanelSetLabelPosition", cInteger, cString);
  AddClipsFunction(cInteger, "panel-set-label-font", "wxcPanelSetLabelFont", cInteger, cInteger);
  AddClipsFunction(cInteger, "panel-set-button-font", "wxcPanelSetButtonFont", cInteger, cInteger);
  AddClipsFunction(cInteger, "panel-new-line", "wxcPanelNewLine", cInteger);
  AddClipsFunction(cInteger, "canvas-create", "wxcCanvasCreate", cInteger, cIntegerOpt, cIntegerOpt, cIntegerOpt,
     cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "canvas-set-scrollbars", "wxcCanvasSetScrollbars", cInteger, cInteger, cInteger,
    cInteger, cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "canvas-scroll", "wxcCanvasScroll", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "canvas-get-dc", "wxcCanvasGetDC", cInteger);
  AddClipsFunction(cInteger, "dc-set-pen", "wxcDCSetPen", cInteger, cInteger);
  AddClipsFunction(cInteger, "dc-set-brush", "wxcDCSetBrush", cInteger, cInteger);
  AddClipsFunction(cInteger, "dc-set-font", "wxcDCSetFont", cInteger, cInteger);
  AddClipsFunction(cInteger, "dc-set-text-foreground", "wxcDCSetTextForeground", cInteger, cString);
  AddClipsFunction(cInteger, "dc-set-text-background", "wxcDCSetTextBackground", cInteger, cString);
  AddClipsFunction(cInteger, "dc-set-logical-function", "wxcDCSetLogicalFunction", cInteger, cString);
  AddClipsFunction(cInteger, "dc-blit", "wxcDCBlit", cInteger, cReal, cReal, cReal, cReal,
     cInteger, cReal, cReal, cStringOpt);
  AddClipsFunction(cInteger, "dc-draw-line", "wxcDCDrawLine", cInteger, cReal, cReal, cReal, cReal);
  AddClipsFunction(cInteger, "dc-draw-point", "wxcDCDrawPoint", cInteger, cReal, cReal);
  AddClipsFunction(cInteger, "dc-draw-rectangle", "wxcDCDrawRectangle", cInteger, cReal, cReal, cReal, cReal);
  AddClipsFunction(cInteger, "dc-draw-rounded-rectangle", "wxcDCDrawRoundedRectangle", cInteger, cReal, cReal, cReal, cReal,
    cReal);
  AddClipsFunction(cInteger, "dc-draw-ellipse", "wxcDCDrawEllipse", cInteger, cReal, cReal, cReal, cReal);
  AddClipsFunction(cInteger, "dc-draw-spline", "wxcDCDrawSpline", cInteger, cList);
  AddClipsFunction(cInteger, "dc-draw-text", "wxcDCDrawText", cInteger, cString, cReal, cReal);
  AddClipsFunction(cInteger, "dc-set-clipping-region", "wxcDCSetClippingRegion", cInteger, cReal, cReal, cReal, cReal);
  AddClipsFunction(cInteger, "dc-destroy-clipping-region", "wxcDCDestroyClippingRegion", cInteger);
  AddClipsFunction(cInteger, "dc-clear", "wxcDCClear", cInteger);
  AddClipsFunction(cInteger, "memory-dc-create", "wxcMemoryDCCreate");
  AddClipsFunction(cInteger, "memory-dc-delete", "wxcMemoryDCCreate", cInteger);
  AddClipsFunction(cInteger, "memory-dc-select-object", "wxcMemoryDCSelectObject", cInteger, cInteger);
  AddClipsFunction(cInteger, "pen-create", "wxcPenCreate", cString, cInteger, cString);
  AddClipsFunction(cInteger, "pen-delete", "wxcPenDelete", cInteger);
  AddClipsFunction(cInteger, "brush-create", "wxcBrushCreate", cString, cString);
  AddClipsFunction(cInteger, "brush-delete", "wxcBrushDelete", cInteger);
  AddClipsFunction(cInteger, "font-create", "wxcFontCreate", cInteger, cString, cString, cString,
    cInteger);
  AddClipsFunction(cInteger, "font-delete", "wxcFontDelete", cInteger);
  AddClipsFunction(cInteger, "icon-create", "wxcIconCreate", cString);
  AddClipsFunction(cInteger, "icon-load-from-file", "wxcIconLoadFromFile", cString);
  AddClipsFunction(cInteger, "icon-delete", "wxcIconDelete", cInteger);
  AddClipsFunction(cInteger, "icon-get-width", "wxcIconGetWidth", cInteger);
  AddClipsFunction(cInteger, "icon-get-height", "wxcIconGetHeight", cInteger);
  AddClipsFunction(cInteger, "bitmap-create", "wxcBitmapCreate", cInteger, cInteger, cIntegerOpt);
  AddClipsFunction(cInteger, "bitmap-load-from-file", "wxcBitmapLoadFromFile", cString);
  AddClipsFunction(cInteger, "bitmap-delete", "wxcBitmapDelete", cInteger);
  AddClipsFunction(cInteger, "bitmap-get-width", "wxcBitmapGetWidth", cInteger);
  AddClipsFunction(cInteger, "bitmap-get-height", "wxcBitmapGetHeight", cInteger);
  AddClipsFunction(cInteger, "mouse-event-is-button", "wxcMouseEventIsButton", cInteger);
  AddClipsFunction(cInteger, "mouse-event-button-down", "wxcMouseEventButtonDown", cInteger);
  AddClipsFunction(cInteger, "mouse-event-control-down", "wxcMouseEventControlDown", cInteger);
  AddClipsFunction(cInteger, "mouse-event-shift-down", "wxcMouseEventShiftDown", cInteger);
  AddClipsFunction(cInteger, "mouse-event-button", "wxcMouseEventButton", cInteger, cInteger);
  AddClipsFunction(cInteger, "mouse-event-left-down", "wxcMouseEventLeftDown", cInteger);
  AddClipsFunction(cInteger, "mouse-event-middle-down", "wxcMouseEventMiddleDown", cInteger);
  AddClipsFunction(cInteger, "mouse-event-right-down", "wxcMouseEventRightDown", cInteger);
  AddClipsFunction(cInteger, "mouse-event-left-up", "wxcMouseEventLeftUp", cInteger);
  AddClipsFunction(cInteger, "mouse-event-middle-up", "wxcMouseEventMiddleUp", cInteger);
  AddClipsFunction(cInteger, "mouse-event-right-up", "wxcMouseEventRightUp", cInteger);
  AddClipsFunction(cInteger, "mouse-event-dragging", "wxcMouseEventDragging", cInteger);
  AddClipsFunction(cReal,    "mouse-event-position-x", "wxcMouseEventPositionX", cInteger);
  AddClipsFunction(cReal,    "mouse-event-position-y", "wxcMouseEventPositionY", cInteger);
  AddClipsFunction(cInteger, "text-window-create", "wxcTextWindowCreate", cInteger, cIntegerOpt, cIntegerOpt,
    cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "text-window-load-file", "wxcTextWindowLoadFile", cInteger, cString);
  AddClipsFunction(cInteger, "text-window-save-file", "wxcTextWindowSaveFile", cInteger, cString);
  AddClipsFunction(cVoid,    "text-window-write",     "wxcTextWindowWrite", cInteger, cUnknown);
  AddClipsFunction(cInteger, "text-window-modified",  "wxcTextWindowModified", cInteger);
  AddClipsFunction(cInteger, "text-window-clear", "wxcTextWindowClear", cInteger);
  AddClipsFunction(cVoid,    "text-window-discard-edits", "wxcTextWindowDiscardEdits", cInteger);
  AddClipsFunction(cInteger, "button-create", "wxcButtonCreate", cInteger, cFunction, cString,
    cIntegerOpt, cIntegerOpt, cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "text-create", "wxcTextCreate", cInteger, cFunction, cString, cString,
    cIntegerOpt, cIntegerOpt, cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "text-set-value", "wxcTextSetValue", cInteger, cString);
  AddClipsFunction(cString,  "text-get-value", "wxcTextGetValue", cInteger);
  AddClipsFunction(cInteger, "multi-text-create", "wxcMultiTextCreate", cInteger, cFunction, cString, cString,
    cInteger, cInteger, cInteger, cInteger, cStringOpt);
  AddClipsFunction(cInteger, "multi-text-set-value", "wxcMultiTextSetValue", cInteger, cString);
  AddClipsFunction(cString,  "multi-text-get-value", "wxcMultiTextGetValue", cInteger);
  AddClipsFunction(cInteger, "check-box-create", "wxcCheckBoxCreate", cInteger, cFunction, cString,
    cIntegerOpt, cIntegerOpt, cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "check-box-set-value", "wxcCheckBoxSetValue", cInteger, cInteger);
  AddClipsFunction(cInteger, "check-box-get-value", "wxcCheckBoxGetValue", cInteger);
  AddClipsFunction(cInteger, "slider-create", "wxcSliderCreate", cInteger, cFunction, cString,
    cInteger, cInteger, cInteger, cInteger, cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "slider-get-value", "wxcSliderSetValue", cInteger, cInteger);
  AddClipsFunction(cInteger, "slider-get-value", "wxcSliderGetValue", cInteger);
  AddClipsFunction(cInteger, "message-create", "wxcMessageCreate", cInteger, cString, cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "list-box-create", "wxcListBoxCreate", cInteger, cFunction, cString, cInteger,
  cIntegerOpt, cIntegerOpt, cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "list-box-append", "wxcListBoxAppend", cInteger, cString, cStringOpt);
  AddClipsFunction(cInteger, "list-box-string", "wxcListBoxFindString", cInteger, cString);
  AddClipsFunction(cInteger, "list-box-clear", "wxcListBoxClear", cInteger);
  AddClipsFunction(cInteger, "list-box-set-selection", "wxcListBoxSetSelection", cInteger, cInteger);
  AddClipsFunction(cInteger, "list-box-deselect", "wxcListBoxDeselect", cInteger, cInteger);
  AddClipsFunction(cInteger, "list-box-get-selection", "wxcListBoxGetSelection", cInteger);
  AddClipsFunction(cString,  "list-box-get-string-selection", "wxcListBoxGetStringSelection", cInteger);
  AddClipsFunction(cInteger, "list-box-set-string-selection", "wxcListBoxSetStringSelection", cInteger, cString);
  AddClipsFunction(cInteger, "list-box-number", "wxcListBoxNumber", cInteger);
  AddClipsFunction(cInteger, "list-box-delete", "wxcListBoxDelete", cInteger, cInteger);
  AddClipsFunction(cString,  "list-box-get-client-data", "wxcListBoxGetClientData", cInteger, cInteger);
  AddClipsFunction(cString,  "list-box-get-string", "wxcListBoxGetString", cInteger, cInteger);
  AddClipsFunction(cInteger, "list-box-get-first-selection", "wxcListBoxGetFirstSelection", cInteger);
  AddClipsFunction(cInteger, "list-box-get-next-selection", "wxcListBoxGetNextSelection", cVoid);
  AddClipsFunction(cInteger, "choice-create", "wxcChoiceCreate", cInteger, cFunction, cString, cIntegerOpt, cIntegerOpt,
    cIntegerOpt, cIntegerOpt, cListOpt, cStringOpt);
  AddClipsFunction(cInteger, "choice-append", "wxcChoiceAppend", cInteger, cString);
  AddClipsFunction(cInteger, "choice-find-string", "wxcChoiceFindString", cInteger, cString);
  AddClipsFunction(cInteger, "choice-clear", "wxcChoiceClear", cInteger);
  AddClipsFunction(cInteger, "choice-set-selection", "wxcChoiceSetSelection", cInteger, cInteger);
  AddClipsFunction(cInteger, "choice-get-selection", "wxcChoiceGetSelection", cInteger);
  AddClipsFunction(cString,  "choice-get-selection", "wxcChoiceGetStringSelection", cInteger);
  AddClipsFunction(cInteger, "choice-set-string-selection", "wxcChoiceSetStringSelection", cInteger, cString);
  AddClipsFunction(cString,  "choice-get-string", "wxcChoiceGetString", cInteger, cInteger);
  AddClipsFunction(cInteger, "menu-create", "wxcMenuCreate", cStringOpt);
  AddClipsFunction(cInteger, "menu-append", "wxcMenuAppend", cInteger, cInteger, cString, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "menu-append-separator", "wxcMenuAppendSeparator", cInteger);
  AddClipsFunction(cInteger, "menu-enable", "wxcMenuEnable", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "menu-check", "wxcMenuCheck", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "menu-bar-create", "wxcMenuBarCreate", cVoid);
  AddClipsFunction(cInteger, "menu-bar-append", "wxcMenuBarAppend", cInteger, cInteger, cString);
  AddClipsFunction(cInteger, "menu-bar-enabel", "wxcMenuBarEnable", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "menu-bar-check", "wxcMenuBarCheck", cInteger, cInteger, cInteger);
  AddClipsFunction(cInteger, "frame-create", "wxcFrameCreate", cInteger, cString, cIntegerOpt, cIntegerOpt,
    cIntegerOpt, cIntegerOpt, cStringOpt);
  AddClipsFunction(cInteger, "frame-set-menu-bar", "wxcFrameSetMenuBar", cInteger, cInteger);
  AddClipsFunction(cInteger, "frame-create-status-line", "wxcFrameCreateStatusLine", cInteger);
  AddClipsFunction(cInteger, "frame-set-status-text", "wxcFrameSetStatusText", cInteger, cString);
  AddClipsFunction(cInteger, "frame-set-icon", "wxcFrameSetIcon", cInteger, cInteger);
  AddClipsFunction(cInteger, "frame-iconize", "wxcFrameIconize", cInteger, cInteger);
  AddClipsFunction(cString,  "get-text-from-user", "wxcGetTextFromUser", cStringOpt, cStringOpt,
    cIntegerOpt);
  AddClipsFunction(cReal,    "string-to-float", "wxcStringToFloat", cString);
  AddClipsFunction(cInteger, "string-to-long", "wxcStringToLong", cString);
  AddClipsFunction(cString,  "float-to-string", "wxcFloatToString", cReal);
  AddClipsFunction(cString,  "long-to-string", "wxcLongToString", cInteger);
  AddClipsFunction(cString,  "string-to-symbol", "wxcStringToSymbol", cString);
  AddClipsFunction(cString,  "symbol-to-string", "wxcSymbolToString", cString);
  AddClipsFunction(cString,  "message-box", "wxcMessageBox", cString, cStringOpt, cIntegerOpt, cIntegerOpt);
  AddClipsFunction(cString,  "file-selector", "wxcFileSelector", cStringOpt,
    cStringOpt, cStringOpt, cStringOpt, cStringOpt, cIntegerOpt);
  AddClipsFunction(cString,  "get-choice", "wxcGetChoice", cString,
    cList, cIntegerOpt, cIntegerOpt);
  AddClipsFunction(cInteger, "yield", "wxcYield", cVoid);
  AddClipsFunction(cInteger, "sleep", "wxcSleep", cInteger);
}
