/*
 * File:	main.h
 * Purpose:	Clips2c main driver program
 * Author:	Julian Smart
 * Created:	1994
 * Updated:	
 * Copyright:	(c) 1993, AIAI, University of Edinburgh
 */

#ifndef __mainh__
#define __mainh__

/* static const char sccsid[] = "%W% %G%"; */

#include "wx.h"
#include "clips2c.h"
#include "iostream.h"

Bool errorHandler(int errorType, char *msg);

#ifndef NO_GUI
// Define a new application type
class MyApp: public wxApp
{ public:
    wxFrame *OnInit(void);
};

// Define a new frame type
class MyFrame: public wxFrame
{ public:
    wxTextWindow *textWindow;
    MyFrame(wxFrame *frame, char *title, int x, int y, int w, int h);
    void OnMenuCommand(int id);
    inline Bool OnClose(void) { return TRUE; }
};
#endif

// ID for the menu quit command
#define CLIPS_QUIT 1
#define CLIPS_GO   2

#define CLIPS_SET_INPUT   3
#define CLIPS_SET_OUTPUT  4

#define CLIPS_VIEW_LATEX  5
#define CLIPS_VIEW_OUTPUT 6

#define CLIPS_VIEW_CUSTOM_MACROS 7
#define CLIPS_LOAD_CUSTOM_MACROS 8

#define CLIPS_MODE_PLAIN    9
#define CLIPS_MODE_WXCLIPS 10
#define CLIPS_MODE_HARDY   11

#define CLIPS_HELP        13
#define CLIPS_ABOUT       14
#define CLIPS_SAVE_FILE   15

extern Bool isInteractive;

extern char *InputFile;
extern char *OutputFile;
extern char *MacroFile;

extern char *FileRoot;

#ifndef NO_GUI
void ChooseOutputFile(Bool force = FALSE);
void ChooseInputFile(Bool force = FALSE);
#endif

#endif // __mainh__
