%{
#include "expr.h"
/* #ifndef __hpux */
int yylex();
yyback();
yylook();
yywrap();
yyoutput();
/*
#else
int yylex(int);
yylook();
yywrap();
yyback(int *, int);
yyoutput(int);
#endif
*/
%}

%union {
    char *s;
/*    struct pexpr *expr; */
}


%start commands

%token <s> INTEGER 1
%token <s> WORD 2
%token <s> STRING 3
%token <s> PERIOD 13
%token OPEN 4
%token CLOSE 5
%token COMMA 6
%token NEWLINE 7
%token ERROR 8
%token OPEN_SQUARE 9
%token CLOSE_SQUARE 10
%token EQUALS 11

/* %type <expr> command expr arglist arg */
%type <s> command expr arglist arg

%%

commands :	/* empty */
	|	commands command
	;

command :       expr
                { process_command($1); }
        ;

expr	:       OPEN CLOSE
                        {$$ = cons(NULL, NULL);}
	|	OPEN arglist CLOSE
			{$$ = $2; }
	;

arglist	:
			{$$ = NULL;}
	|	arg
			{$$ = cons($1, NULL);}
	|
		arg arglist
			{$$ = cons($1, $2);}
	;


arg	:	WORD
			{$$ = make_word($1); free($1);}
	|	STRING
			{$$ = make_string($1); free($1);}
	|	INTEGER
			{$$ = make_integer($1); free($1);}
	|	INTEGER PERIOD INTEGER
			{$$ = make_real($1, $3); free($1); free($2); free($3); }
	|	expr
			{$$ = $1;}
	;

%%

#include "lex_yy.c"

void yyerror(s)
char *s;
{
  syntax_error();
/*  return 0; */
}

int yywrap()
{
/*    printf("yywrap() called\n"); */
    return 1;
}

